
/*
 *	FILE IO		-	GENERAL
 */

// fopen opens the file for reading or writing. if the 2nd param is "r" then it
// will open for reading ascii, if it is "w" then it will open the file for writing ascii.
// "rb" = read binary
// "wb" = write binary
//
FILE* fopen(const char* filename,const char *mode);

// fclose will close the file
// 
void fclose(FILE *fp);

// fgetc returns the next byte in the file
//
int fgetc(FILE* fp);

// fputc puts a byte into the file 
// 
int fputc(int byte,FILE* fp);

// ftell returns the position in the file in bytes from the start
//
int ftell(FILE* fp);

// fseek will move you to the requested location. ie,
// 
//	fseek(fp,10,SEEK_SET);		-	move to 10 bytes after the beginning
//	fseek(fp,10,SEEK_END);		-	moves to 10bytes before end of file
//	fseek(fp,10,SEEK_CUR);		-	moves 10bytes on from current position

void fseek(FILE* fp,long byteCount,int ConstThing);



/*
 *	ASCII file IO
 */

// same as scanf, however 1st parameter is the file pointer
//
int fscanf(FILE* fp, const char *str,... );

// same as printf, however 1st parameter is the file pointer
//
int fprintf(FILE* fp, const char *str,... );




/*
*	BINARY file IO
*/




// fread reads binary data from file, ie :
//
// int Array[10];
// fread(Array,10,sizeof(int),fp);
// 
int fread(void* Adress,int num_elements,int sizeof_element,FILE* fp);




// fread writes binary data to the file, ie :
//
// int Array[10];
// fwrite(Array,10,sizeof(int),fp);
// 
int fwrite(void* Adress,int num_elements,int sizeof_element,FILE* fp);







