#include <stdio.h>
#include <stdlib.h>


struct treeNode
{
	struct treeNode* left;
	struct treeNode* right;
	int data;
};
typedef struct treeNode treeNode;
treeNode* tree = NULL;

treeNode* ReadNode(FILE* fp)
{
	char buffer [10];
	fscanf (fp, "%s", buffer);

	// see if node exists....
	if (buffer [0] == 'n' && 
		buffer [1] == 'o' &&
		buffer [2] == 'd' && 
		buffer [3] == 'e') {

			// create new node 
			treeNode* node = (treeNode*)malloc(sizeof(treeNode));
			node->right = NULL;
			node->left = NULL;

			// read data for this node
			fscanf(fp, "%d", &node->data);

			// LEFT
			{
				int hasLeft;
				fscanf(fp, "%d", &hasLeft);

				// if left branch exists
				if (hasLeft) 
					node->left = ReadNode(fp);
			}

			// RIGHT
			{
				int hasRight;
				fscanf(fp, "%d", &hasRight);

				// if right branch exists
				if (hasRight) 
					node->right = ReadNode(fp);
			}

			// return the tree node....
			return node;
	}

	return NULL;
}


treeNode* ReadBinNode(FILE* fp)
{
	char buffer [4];
	fread(buffer,4,1,fp);

	// see if node exists....
	if (buffer [0] == 'n' && 
		buffer [1] == 'o' &&
		buffer [2] == 'd' && 
		buffer [3] == 'e') {

			// create new node 
			treeNode* node = (treeNode*)malloc(sizeof(treeNode));
			node->right = NULL;
			node->left = NULL;

			// read data for this node
			fread(&node->data,1,sizeof(int),fp);

			// LEFT
			{
				int hasLeft;
				fread(&hasLeft,1,sizeof(int),fp);

				// if left branch exists
				if (hasLeft) 
					node->left = ReadNode(fp);
			}

			// RIGHT
			{
				int hasRight;
				fread(&hasRight,1,sizeof(int),fp);

				// if right branch exists
				if (hasRight) 
					node->right = ReadNode(fp);
			}

			// return the tree node....
			return node;
		}

		return NULL;
}

void SaveBinNode(FILE* fp,treeNode* node)
{
	char buffer [4] = {'n','o','d','e'};

	// see if node exists....
	if (node != NULL) {
		fwrite(buffer,4,1,fp);

		// read data for this node
		fwrite(&node->data,1,sizeof(int),fp);

		// LEFT
		{
			int hasLeft=0;

			// if left branch exists
			if (node->left != NULL) 
				hasLeft = 1;

			fwrite(&hasLeft,1,sizeof(int),fp);

			SaveBinNode(fp,node->left);
		}

		// RIGHT
		{
			int hasRight=0;

			// if left branch exists
			if (node->right != NULL) 
				hasRight = 1;

			fwrite(&hasRight,1,sizeof(int),fp);

			SaveBinNode(fp,node->right);
		}
	}
}





void load(char* file)
{
	FILE* fp = fopen(file,"r");

	tree = ReadNode(fp);

	fclose(fp);
}

void main()
{
	load("tree.txt");
}
