
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <GL/glut.h>

struct mousey 
{
	int x, y;
	struct mousey* ptr;
};

typedef struct mousey mousey;

//
//		---------------------
//		|		Node		|
//		|					|------> X
//		---------------------
//		  /				  \
//		 /				   \
//		/					\
//
mousey* end   = NULL;	mousey* start = NULL;

void enqueue(int x, int y)
{
	//------------------------------------------------------
	//
	//	This is the same for all dynamic data structures!!!
	//
	mousey* newNode = (mousey*)malloc(sizeof(mousey));
	assert (newNode != NULL);

	// set data
	newNode->x = x;
	newNode->y = y;

	//-------------------------------------------------------

	newNode->ptr = NULL;

	// if queue is empty.....
	if (start == NULL) {
		start = end = newNode;
	}
	else
	{
	   	// add to front of queue
		start->ptr   = newNode;
		start = newNode;
	}
}

void dequeue()
{
	if(end != NULL)
	{
		mousey* tmp = end;

		// if only one node in queue, ie if start and end are pointing to same node
		if (end == start) {
			end = start = NULL;
		}
		else
		{
			end = end->ptr;
		}

		free(tmp);
	}
}

void init()
{
}

void draw()
{
	mousey* curr = end;

	glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );

	glBegin (GL_LINE_STRIP);

	while (curr != NULL)
	{
		glVertex2i(curr->x,curr->y);

		curr = curr->ptr;
	}

	glEnd();

	glutSwapBuffers();
}

void reshape(int w, int h)
{
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,w,h,0,-100,100);	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void mouse(int button,int state,int x,int y)
{
	// push
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
	{
		enqueue(x,y);
	}	
	if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
	{
		dequeue();
	}
	glutPostRedisplay();
}

int main(int argc,char** argv)
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DEPTH|GLUT_RGBA|GLUT_DOUBLE);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(100,100);

	glutCreateWindow("fred");

	glutDisplayFunc(draw);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);

	init();

	glutMainLoop();
}













