
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <GL/glut.h>

struct Particle 
{
	float x;
	float y;
	float dx;
	float dy;
	int   life;

	struct Particle* ptr;
};

typedef struct Particle Particle;


Particle* list = NULL;

void insertAtFront()
{
	Particle* newNode = (Particle*)malloc(sizeof(Particle));
	assert (newNode != NULL);

	// set data
	newNode->x = 400;
	newNode->y = 300;
	newNode->dx = (100 - rand()%200)/100.0f;
	newNode->dy = (100 - rand()%200)/100.0f;
	newNode->life = 50 + rand()%300;

	// add to front of list, aka "top"
	newNode->ptr = list;

	list = newNode;
}

void removeDeadOnes()
{
	Particle* curr = list,*prev = NULL;

	while (curr != NULL) {

		if (curr->life == 0) {
			// remove this particle....
            Particle* temp = curr;

			curr = curr->ptr;

			// if we are removing the first element in the list
			if (prev == NULL) {
				list = curr;
			}
			else
				prev->ptr = curr;

			free(temp);
		}
		else
		{
			prev = curr;
			curr = curr->ptr;
		}
	}

}

void draw()
{
	Particle* ptr = list;

	glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );

	glBegin (GL_POINTS);

	while (ptr != NULL)
	{
		glVertex2i(ptr->x,ptr->y);
		ptr = ptr->ptr;
	}

	glEnd();

	glutSwapBuffers();
}

void reshape(int w, int h)
{
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,w,h,0,-100,100);	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void idle()
{
	int i,numToCreate;

	Particle* ptr = list;
	while (ptr != NULL)
	{
		ptr->x += ptr->dx;
		ptr->y += ptr->dy;
		ptr->life--;

		ptr = ptr->ptr;
	}

	numToCreate = rand()%10;
	for(i=0;i<numToCreate;++i)
		insertAtFront();

	removeDeadOnes();

	glutPostRedisplay();
}

int main(int argc,char** argv)
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DEPTH|GLUT_RGBA|GLUT_DOUBLE);
	glutInitWindowSize(800,600);
	glutInitWindowPosition(100,100);

	glutCreateWindow("fred");

	glutDisplayFunc(draw);
	glutReshapeFunc(reshape);
	glutIdleFunc(idle);

	glutMainLoop();
}













