
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <GL/glut.h>

struct mousey 
{
	int x, y;
};

typedef struct mousey mousey;

mousey stack[64];
int stacksize = 0;


void draw()
{
	int i;
	glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );
	glBegin (GL_LINE_STRIP);

	for(i=0;i<stacksize;i++)
	{
		glVertex2i(stack[i].x,stack[i].y);
	}

	glEnd();
	glutSwapBuffers();
}

void mouse(int button,int state,int x,int y)
{
	// push
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
	{
		stack[stacksize].x = x;
		stack[stacksize].y = y;
		stacksize++;
	}	
	if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
	{
		if (stacksize != 0)
			stacksize--;
	}
	glutPostRedisplay();
}

void reshape(int w, int h)
{
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,w,h,0,-100,100);	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

int main(int argc,char** argv)
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DEPTH|GLUT_RGBA|GLUT_DOUBLE);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(100,100);

	glutCreateWindow("fred");

	glutDisplayFunc(draw);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);

	glutMainLoop();
}
