
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <GL/glut.h>

struct mousey 
{
	int x, y;
	struct mousey* ptr;
};

typedef struct mousey mousey;
//first node in stack
mousey* stack = NULL;

void push(int x, int y)
{
	mousey* newNode = (mousey*)malloc(sizeof(mousey));
	assert (newNode != NULL);

	// set data
	newNode->x = x;
	newNode->y = y;

	// add to front of stack, aka "top"
	newNode->ptr = stack;

	stack = newNode;
}

void pop()
{
	if(stack != NULL)
	{
		mousey* top = stack;
		stack = stack->ptr;
		free(top);
	}
}

void init()
{
}

void draw()
{
	// create pointer to first element
	mousey* temp = stack;

	glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );
	glBegin (GL_LINE_STRIP);

	// while not at end of list
	while (temp != NULL)
	{
		// do shit with data
		glVertex2i(temp->x,temp->y);

		// move to next element
		temp = temp->ptr;
	}

	glEnd();

	glutSwapBuffers();
}

void reshape(int w, int h)
{
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,w,h,0,-100,100);	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void mouse(int button,int state,int x,int y)
{
	// push
	if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
	{
		push(x,y);
	}	
	if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
	{
		pop();
	}
	glutPostRedisplay();
}

int main(int argc,char** argv)
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DEPTH|GLUT_RGBA|GLUT_DOUBLE);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(100,100);

	glutCreateWindow("fred");

	glutDisplayFunc(draw);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);

	init();

	glutMainLoop();
}













