///-----------------------------------------------------------------------------
/// 
/// \file	Light.h
/// \author	Rob Bateman
/// \brief	This file defines the class XLight whixh is used to hold information
///			about a light. 
/// 
///-----------------------------------------------------------------------------

#pragma once

#include <iostream>

class XLight
{
	friend std::istream &operator>>(std::istream&,XLight&);

public:


	/// ctor
	XLight(unsigned int id);

	/// dtor
	~XLight(void);

	/// this function draws the mesh data
	void Enable();

	/// this function draws the mesh data
	void Disable();

protected:
	
	/// openGl supports up to eight lights.
	unsigned int m_LightNum;

	/// the intensity of the light
	float m_fIntensity;

	/// the lights colour
	float m_Color[4];

	/// the position of the light
	float m_Position[4];
};
