//////////////////////////////////////////////////////////////////////////
/// The XModel class basically holds the contents of a read file. This may
/// contain a number of 


#pragma once

//////////////////////////////////////////////////////////////////////////

#include <vector>
#include <list>
#include "./Light.h"
#include "./Mesh.h"

//////////////////////////////////////////////////////////////////////////


/// a list of lights type
typedef std::vector< XLight* > XLightList;

/// an iterator for a light list
typedef XLightList::iterator XItLight;



/// a list of lights type
typedef std::vector< XMesh* > XMeshList;

/// an iterator for a light list
typedef XMeshList::iterator XItMesh;


//////////////////////////////////////////////////////////////////////////

class XModel
{
public:

	/// ctor
	XModel(void);

	/// dtor
	~XModel(void);

	/// a function to draw the geometry data in the model
	void gl();

	/// a function to load a file into the model
	bool Load(const char* const filename);

protected:

	/// this Function enables all of the lights in the model
	void EnableLights();

	/// this function disables all of the lights in the model
	void DisableLights();

	/// a list of lights
	XLightList m_Lights;

	/// a list of meshes
	XMeshList m_Meshes;
};
