///-----------------------------------------------------------------------------
/// 
/// \file	Texture.cpp
/// \author	Rob Bateman
/// \brief	This file defines the XImageHeader and the XTexture classes. These 
///			are used to read a texture file from a texture file
/// 
///-----------------------------------------------------------------------------

#include "texture.h"
#include <assert.h>

XTexture::XTexture(void)
{
}

XTexture::~XTexture(void)
{
}

/// this function reads a texture from the specified file pointer
bool XTexture::Read(FILE* fp)
{
	// read the 2 byte image header
	if( 0 != fread(&m_Header,sizeof(XImageHeader),1,fp) )
	{
		// get the size of the pixel data
		unsigned int size = GetWidth()*GetHeight()*GetBytesPerPixel();

		// allocate memory for it
		m_Pixels = new unsigned char [ size ];
		assert(m_Pixels);

		// read the pixel data from the file
		if(0!=fread(m_Pixels,size,1,fp))
			return true;
	}
	return false;
}