
#ifdef WIN32
#include<Windows.h>
#endif

#include <GL/glut.h>

#include "Model.h"
#include "TextureFile.h"

XTextureFile texFile;
XModel model;
int w;
int h;
float rot = 0;

void Init() {
//	glEnable(GL_LIGHTING);
//	glEnable(GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);
	model.Load("poo.mod");
	texFile.Load("poo.tex");
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45,(float)w/h,0.1,100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	gluLookAt(2,8,20,0,0,0,0,1,0);

	glPushMatrix();

		glRotatef(rot,0,1,0);

		model.gl();

	glPopMatrix();

	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,w,0,h,-100,100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	XTexture* tex = texFile.GetTexture(1);
	glRasterPos2i(100,100);
	glDrawPixels(tex->GetWidth(),tex->GetHeight(),((tex->GetBytesPerPixel()==3)?GL_RGB:GL_RGBA),GL_UNSIGNED_BYTE,tex->GetPixels());

	glutSwapBuffers();
}

void reshape(int x, int y)
{
	if(y==0) y = 1;
	glViewport(0,0,x,y);
	w=x;
	h=y;
}

void idle()
{
	rot++;
	glutPostRedisplay();
}



int main(int argc,char** argv)
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(100,100);
	glutCreateWindow("hello");


	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutIdleFunc(idle);

	Init();

	glutMainLoop();
}

























