/////////////////////////////////////////////////////////////////////////////////////////
/// 
///	\file	Light.h
/// \author	Rob Bateman			( robthebloke@hotmail.com )
/// \brief	This file defines the single function OutputLight which will write the light
///			data to the file. 
///
/////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#ifndef LIGHT_H_INCLUDED
#define LIGHT_H_INCLUDED

/////////////////////////////////////////////////////////////////////////////////////////

#include <maya/MObject.h>


/////////////////////////////////////////////////////////////////////////////////////////

/// \brief	This function outputs the Light to the specified file stream
/// \param	ofs	-	the output file stream
/// \param	obj	-	the handle to the maya node
/// 
extern void OutputLight(std::ofstream& ofs,MObject &obj);



#endif