#pragma once

#include "Bone.h"

class XBoneAnimation
{
public:

	/// ctor
	XBoneAnimation();
	
	/// dtor
	~XBoneAnimation(void);

	/// this func updates the current anim cycle
	void Update(XBone& bone,float delta) 
	{
		if(bone.GetID()==8)
			int ib=0;
		m_fCurrTime += delta;
		
		while (m_fCurrTime > 1) {
			m_fCurrTime -= 1;
		}
		int index = (int) ((float)25*m_fCurrTime);

		float t = (m_fCurrTime - index*0.04f)/0.04f  ;
		
		if(index < 24)
			m_CurrValue = SLERP(m_Quaternions[index],m_Quaternions[index+1],t);
		else
			m_CurrValue = m_Quaternions[m_Quaternions.size()-1];

		bone.m_Rotation = m_CurrValue;
	}

	const XQuaternion& GetVal() const {
		return m_CurrValue;
	}

	friend std::istream& operator >> (std::istream& ifs,XBoneAnimation &ba) {
		ifs >> ba.m_BoneID;
		XQuaternion q;
		for(int i=0;i<25;++i) {
			ifs >> q;
			ba.m_Quaternions.push_back(q);
		}
		return ifs;
	}
	unsigned int GetID() {
		return m_BoneID;
	}

protected:

	/// the bone ID
	unsigned int m_BoneID;

	/// the current value of th rotation
	XQuaternion m_CurrValue;

	/// the current time
	float m_fCurrTime;

	/// the keyframes
	std::vector< XQuaternion > m_Quaternions;
};
