///-----------------------------------------------------------------------------
/// 
/// \file	Light.h
/// \author	Rob Bateman
/// \brief	This file defines the class XLight whixh is used to hold information
///			about a light. 
/// 
///-----------------------------------------------------------------------------

#include "light.h"
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <Windows.h>
#endif
#include <GL/GL.h>


XLight::XLight(unsigned int id)
	: m_LightNum(id)
{
	m_Color[0] = 0;
	m_Color[1] = 0;
	m_Color[2] = 0;
	m_Color[3] = 0;
	m_Position[0] = 0;
	m_Position[1] = 0;
	m_Position[2] = 7;
	m_Position[3] = 1;
}

XLight::~XLight(void)
{
}

/// this function draws the mesh data
void XLight::Enable()
{
	/// set the diffuse colour
	glLightfv(GL_LIGHT0 + m_LightNum,GL_DIFFUSE,m_Color);
	
	/// set the lights position
	glLightfv(GL_LIGHT0 + m_LightNum,GL_POSITION,m_Position);

	/// enable the light
	glEnable(GL_LIGHT0 + m_LightNum);
}

/// this function draws the mesh data
void XLight::Disable()
{
	glDisable(GL_LIGHT0 + m_LightNum);
}


std::istream &operator>>(std::istream& ifs,XLight& l) {
	char buffer[64];
	ifs >> buffer; // name
	ifs >> buffer; // "id"
	ifs >> l.m_ID;
	ifs >> buffer; // "Type="
	ifs >> buffer; // kPointLight, kAmbientLight, kSpotLight etc
	ifs >> buffer; // "Color="

	ifs >> l.m_Color[0] >> l.m_Color[1] >> l.m_Color[2];

	ifs >> buffer; // "Intensity="

	ifs >> l.m_fIntensity;

	ifs >> buffer >> buffer; // "Parent="

	return ifs;
}