 ///-----------------------------------------------------------------------------
/// 
/// \file	Light.h
/// \author	Rob Bateman
/// \brief	This file defines the class XLight whixh is used to hold information
///			about a light. 
/// 
///-----------------------------------------------------------------------------

#pragma once

#include <iostream>

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <Windows.h>
#endif
#include <GL/GL.h>

#include "./Object.h"

class XLight : public XObject
{
	friend std::istream &operator>>(std::istream&,XLight&);

public:


	/// ctor
	XLight(unsigned int id);

	/// dtor
	~XLight(void);

	/// this function draws the mesh data
	void Enable();

	/// this function draws the mesh data
	void Disable();

	/// this functions sets the lights position
	void gl(XMaterialList& mats) 
	{
		float pos[] = {0,0,9,1};
		glLightfv(GL_LIGHT0+m_LightNum,GL_POSITION,pos);
	}

	void UpdatePosition(float x,float y,float z) {
		m_Position[0] = x;
		m_Position[1] = y;
		m_Position[2] = z;
	}

protected:
	
	/// openGl supports up to eight lights.
	unsigned int m_LightNum;

	/// the intensity of the light
	float m_fIntensity;

	/// the lights colour
	float m_Color[4];

	/// the position of the light
	float m_Position[4];
};
