#include "material.h"
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <Windows.h>
#endif
#include <GL/GL.h>

XMaterial::XMaterial(void)
{
}

XMaterial::~XMaterial(void)
{
}

/// as an optimisation, we will track which material is currently in use. This will 
/// try to minimise the state changes within OpenGL
XMaterial* XMaterial::ms_CurrentMaterial = NULL;


void XMaterial::gl(){
	// make sure we don't bind the material more than nessecary
	if (this==ms_CurrentMaterial) {
		return;
	}
	ms_CurrentMaterial = this;

	if (m_Diffuse.m_TextureObject!=0) {
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,m_Diffuse.m_TextureObject);
	}
	else {
		glDisable(GL_TEXTURE_2D);
	}

	glMaterialfv(GL_FRONT,GL_AMBIENT,m_Ambient.m_Colour);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,m_Diffuse.m_Colour);
	glMaterialfv(GL_FRONT,GL_SPECULAR,m_Specular.m_Colour);
	glMaterialfv(GL_FRONT,GL_EMISSION,m_Emission.m_Colour);
	glMaterialf(GL_FRONT,GL_SHININESS,m_Shininess);
}

	
std::istream& operator >> (std::istream& ifs,XPhong& ph)
{
	char buffer[256];

	ifs >> buffer // name
		>> ph.m_Ambient
		>> ph.m_Diffuse
		>> ph.m_Specular
		>> ph.m_Emission
		>> ph.m_Transparency
		>> buffer // shininess
		>> ph.m_Shininess;
		return ifs;
}

std::istream& operator >> (std::istream& ifs,XLambert& ph)
{
	char buffer[256];

	ifs >> buffer // name
		>> ph.m_Ambient
		>> ph.m_Diffuse
		>> ph.m_Emission
		>> ph.m_Transparency;

		return ifs;
}

std::istream& operator >> (std::istream& ifs,XBlinn& ph)
{
	char buffer[256];

	ifs >> buffer // name
		>> ph.m_Ambient
		>> ph.m_Diffuse
		>> ph.m_Specular
		>> ph.m_Emission
		>> ph.m_Transparency
		>> buffer // shininess
		>> ph.m_Shininess;
		return ifs;
}