/*----------------------------------------------------------------------------------*\
 *	file:	Vector.c
 *	author:	
 *	date:	
 *	notes:	
\*----------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------*\
 *		Includes
\*----------------------------------------------------------------------------------*/

/* c std library includes */
#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* windows compilation requires windows.h */
#ifdef WIN32
	/* This speeds up compile time on WIN32 by excluding lots of rubbish stuff */
	#define WIN32_LEAN_AND_MEAN	
	#include <Windows.h>
#endif

/* open gl includes */
#include <GL/gl.h>
#include <GL/GLU.h>

/* custom includes */
#include "Vector.h"


/*----------------------------------------------------------------------------------*\
 *		Defines
\*----------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------*\
 *		Data Types
\*----------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------*\
 *		Globals
\*----------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------*\
 *		Functions
\*----------------------------------------------------------------------------------*/


/*
 *	\brief	This function performs the dot product between 2 vectors.
 *	\param	a	-	the first of 2 vectors
 *	\param	b	-	the second of two vectors
 *	\return	the dot product as a float
 */
float dotproduct (vec* a,vec* b)
{
	/*
	 *	Note: we use the -> operator to access variables within 
	 *		  a structure when dealing with pointers to structures.
	 */
	return a->x * b->x + 
		   a->y * b->y + 
		   a->z * b->z ;
}
