 //==========================================================================
//
//	FILE:	Font.c
//	AUTHOR:	Rob Bateman
//	DATE:	Somewhen last century
//	NOTE:
//
//
//	This file defines a small bitmap font for use in openGL
//
//	USAGE:
//
//
//	Call the function FontDraw() specifying the text to write, and the 2D
//	screen co-ordinates of where you will be drawing the font. The first
//	paremeter can be one of the following :
//
//					GLUT_BITMAP_9_BY_15		
//					GLUT_BITMAP_8_BY_13			
//					GLUT_BITMAP_TIMES_ROMAN_10	
//					GLUT_BITMAP_TIMES_ROMAN_24	
//					GLUT_BITMAP_HELVETICA_10	
//					GLUT_BITMAP_HELVETICA_12	
//					GLUT_BITMAP_HELVETICA_18	
//
//	Use glColor3f() or glColor4f() to specify the colour of the font to be
//	drawn.
//
//==========================================================================

#include "font.h"
#ifdef WIN32
#include <windows.h>
#endif
#include <GL/glut.h>
#include <stdio.h>
#include <string.h>


//==========================================================================
//
//	note:	This function returns the width of a single ascii character
//
//==========================================================================
int CharWidth(void* font,char c)
{
	return glutBitmapWidth( font, c );
}

//==========================================================================
//
//	Print string to window using glut bitmap fonts
//
//==========================================================================
void FontDraw(void* font,char *txt, int x, int y)
{
	glRasterPos2i(x, y);

	while( *txt != '\0' )
	{
		glutBitmapCharacter( font, *txt );
		++txt;
	}
}



//==========================================================================
//
//	note:	call this function to determine the length of a text string
//
//==========================================================================
int FontLength(void* font,char *txt)
{
	return glutBitmapLength( font, txt );
}

