//==========================================================================
//
//	FILE:	Font.h
//	AUTHOR:	Rob Bateman
//	DATE:	Somewhen last century
//	NOTE:
//
//	This file defines a small bitmap font for use in openGL
//
//	USAGE:
//
//
//	Call the function FontDraw() specifying the text to write, and the 2D
//	screen co-ordinates of where you will be drawing the font. The first
//	paremeter can be one of the following :
//
//					GLUT_BITMAP_9_BY_15		
//					GLUT_BITMAP_8_BY_13			
//					GLUT_BITMAP_TIMES_ROMAN_10	
//					GLUT_BITMAP_TIMES_ROMAN_24	
//					GLUT_BITMAP_HELVETICA_10	
//					GLUT_BITMAP_HELVETICA_12	
//					GLUT_BITMAP_HELVETICA_18	
//
//	Use glColor3f() or glColor4f() to specify the colour of the font to be
//	drawn.
//
//==========================================================================


#pragma once

#ifndef SMALL_FONT_H
#define SMALL_FONT_H


// this is required for C compatibility with C++
#ifdef __cplusplus
extern "C" {
#endif



//==========================================================================
//
//	note:	This function returns the width of a single ascii character
//
//==========================================================================

extern int CharWidth(void* font,char c);


//==========================================================================
//
//	note:	This function allows you to draw the text string in the
//			position (x,y).
//	param:	font-	the font type to use
//	param:	txt	-	the text to write
//	param:	x	-	x coordinate of text
//	param:	y	-	y coordinate of text
//
//==========================================================================

extern void FontDraw(void *font,char *txt,int x,int y);


//==========================================================================
//
//	note:	call this function to determine the length of a text string
//
//==========================================================================

extern int FontLength(void* font,char *txt);


// this is required for C compatibility with C++
#ifdef __cplusplus
};
#endif



#endif
